/*
 * OpenAPI
 *
 * OpenAPI
 *
 * The version of the OpenAPI document: 0.0.1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = HubsanteModel/Cisu.Client.OpenAPIDateConverter;

namespace HubsanteModel/Cisu.Model
{
    /// <summary>
    /// Victims
    /// </summary>
    [DataContract(Name = "victims")]
    public partial class Victims : IValidatableObject
    {
        /// <summary>
        /// Indique le nombre de victimes selon la nomenclature du référentiel CISU
        /// </summary>
        /// <value>Indique le nombre de victimes selon la nomenclature du référentiel CISU</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum CountEnum
        {
            /// <summary>
            /// Enum _0 for value: 0
            /// </summary>
            [EnumMember(Value = "0")]
            _0 = 1,

            /// <summary>
            /// Enum _1 for value: 1
            /// </summary>
            [EnumMember(Value = "1")]
            _1 = 2,

            /// <summary>
            /// Enum PLUSIEURS for value: PLUSIEURS
            /// </summary>
            [EnumMember(Value = "PLUSIEURS")]
            PLUSIEURS = 3,

            /// <summary>
            /// Enum BEAUCOUP for value: BEAUCOUP
            /// </summary>
            [EnumMember(Value = "BEAUCOUP")]
            BEAUCOUP = 4,

            /// <summary>
            /// Enum INCONNU for value: INCONNU
            /// </summary>
            [EnumMember(Value = "INCONNU")]
            INCONNU = 5,

            /// <summary>
            /// Enum NONDEFINI for value: NON DEFINI
            /// </summary>
            [EnumMember(Value = "NON DEFINI")]
            NONDEFINI = 6
        }


        /// <summary>
        /// Indique le nombre de victimes selon la nomenclature du référentiel CISU
        /// </summary>
        /// <value>Indique le nombre de victimes selon la nomenclature du référentiel CISU</value>
        /*
        <example>example.json#/qualification/victims/count</example>
        */
        [DataMember(Name = "count", EmitDefaultValue = false)]
        public CountEnum? Count { get; set; }
        /// <summary>
        /// Identifie le type de la principale victime (celle dont l&#39;état de santé provoque le déclenchement de l&#39;envoi des secours). Prend les valeurs du référentiel CISU. Entre dans la détermination des partenaires impliqués par NexSIS.
        /// </summary>
        /// <value>Identifie le type de la principale victime (celle dont l&#39;état de santé provoque le déclenchement de l&#39;envoi des secours). Prend les valeurs du référentiel CISU. Entre dans la détermination des partenaires impliqués par NexSIS.</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum MainVictimEnum
        {
            /// <summary>
            /// Enum NOURRISSON for value: NOURRISSON
            /// </summary>
            [EnumMember(Value = "NOURRISSON")]
            NOURRISSON = 1,

            /// <summary>
            /// Enum ENFANT for value: ENFANT
            /// </summary>
            [EnumMember(Value = "ENFANT")]
            ENFANT = 2,

            /// <summary>
            /// Enum ADULTE for value: ADULTE
            /// </summary>
            [EnumMember(Value = "ADULTE")]
            ADULTE = 3,

            /// <summary>
            /// Enum SENIOR for value: SENIOR
            /// </summary>
            [EnumMember(Value = "SENIOR")]
            SENIOR = 4,

            /// <summary>
            /// Enum ENCEINTE for value: ENCEINTE
            /// </summary>
            [EnumMember(Value = "ENCEINTE")]
            ENCEINTE = 5
        }


        /// <summary>
        /// Identifie le type de la principale victime (celle dont l&#39;état de santé provoque le déclenchement de l&#39;envoi des secours). Prend les valeurs du référentiel CISU. Entre dans la détermination des partenaires impliqués par NexSIS.
        /// </summary>
        /// <value>Identifie le type de la principale victime (celle dont l&#39;état de santé provoque le déclenchement de l&#39;envoi des secours). Prend les valeurs du référentiel CISU. Entre dans la détermination des partenaires impliqués par NexSIS.</value>
        /*
        <example>example.json#/qualification/victims/mainVictim</example>
        */
        [DataMember(Name = "mainVictim", EmitDefaultValue = false)]
        public MainVictimEnum? MainVictim { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="Victims" /> class.
        /// </summary>
        /// <param name="count">Indique le nombre de victimes selon la nomenclature du référentiel CISU.</param>
        /// <param name="mainVictim">Identifie le type de la principale victime (celle dont l&#39;état de santé provoque le déclenchement de l&#39;envoi des secours). Prend les valeurs du référentiel CISU. Entre dans la détermination des partenaires impliqués par NexSIS..</param>
        /// <param name="freetext">Permet de complémenter en commentaire libre la(les) victime(s).</param>
        public Victims(CountEnum? count = default(CountEnum?), MainVictimEnum? mainVictim = default(MainVictimEnum?), string freetext = default(string))
        {
            this.Count = count;
            this.MainVictim = mainVictim;
            this.Freetext = freetext;
        }

        /// <summary>
        /// Permet de complémenter en commentaire libre la(les) victime(s)
        /// </summary>
        /// <value>Permet de complémenter en commentaire libre la(les) victime(s)</value>
        /*
        <example>example.json#/qualification/victims/freetext</example>
        */
        [DataMember(Name = "freetext", EmitDefaultValue = false)]
        public string Freetext { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class Victims {\n");
            sb.Append("  Count: ").Append(Count).Append("\n");
            sb.Append("  MainVictim: ").Append(MainVictim).Append("\n");
            sb.Append("  Freetext: ").Append(Freetext).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
