/*
 * OpenAPI
 *
 * OpenAPI
 *
 * The version of the OpenAPI document: 0.0.1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = HubsanteModel/Resources.status.Client.OpenAPIDateConverter;

namespace HubsanteModel/Resources.status.Model
{
    /// <summary>
    /// ResourcesStatus
    /// </summary>
    [DataContract(Name = "resourcesStatus")]
    public partial class ResourcesStatus : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourcesStatus" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ResourcesStatus() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourcesStatus" /> class.
        /// </summary>
        /// <param name="caseId">A valoriser avec l&#39;identifiant partagé de l&#39;affaire/dossier, généré une seule fois par le système du partenaire qui recoit la primo-demande de secours (créateur du dossier).  Il est valorisé comme suit lors de sa création :  {pays}.{domaine}.{organisation}.{senderCaseId}  Il doit pouvoir être généré de façon décentralisée et ne présenter aucune ambiguïté.  Il doit être unique dans l&#39;ensemble des systèmes : le numéro de dossier fourni par celui qui génère l&#39;identifiant partagé doit donc être un numéro unique dans son système. (required).</param>
        /// <param name="resourceId">A valoriser avec l&#39;identifiant partagé unique de la ressource engagée , normé comme suit : {orgID}.R.{ID unique de la ressource partagée} Ou, uniquement dans le cas où un ID unique de ressource ne peut pas être garanti par l&#39;organisation propriétaire : {orgID}.R.{ID du dossier partagé}.{numéro d’ordre chronologique ressource}  N.B. Il s&#39;agit de l&#39;orgId de l&#39;organisation à qui appartient la ressource (required).</param>
        /// <param name="state">state (required).</param>
        public ResourcesStatus(string caseId = default(string), string resourceId = default(string), State state = default(State))
        {
            // to ensure "caseId" is required (not null)
            if (caseId == null)
            {
                throw new ArgumentNullException("caseId is a required property for ResourcesStatus and cannot be null");
            }
            this.CaseId = caseId;
            // to ensure "resourceId" is required (not null)
            if (resourceId == null)
            {
                throw new ArgumentNullException("resourceId is a required property for ResourcesStatus and cannot be null");
            }
            this.ResourceId = resourceId;
            // to ensure "state" is required (not null)
            if (state == null)
            {
                throw new ArgumentNullException("state is a required property for ResourcesStatus and cannot be null");
            }
            this.State = state;
        }

        /// <summary>
        /// A valoriser avec l&#39;identifiant partagé de l&#39;affaire/dossier, généré une seule fois par le système du partenaire qui recoit la primo-demande de secours (créateur du dossier).  Il est valorisé comme suit lors de sa création :  {pays}.{domaine}.{organisation}.{senderCaseId}  Il doit pouvoir être généré de façon décentralisée et ne présenter aucune ambiguïté.  Il doit être unique dans l&#39;ensemble des systèmes : le numéro de dossier fourni par celui qui génère l&#39;identifiant partagé doit donc être un numéro unique dans son système.
        /// </summary>
        /// <value>A valoriser avec l&#39;identifiant partagé de l&#39;affaire/dossier, généré une seule fois par le système du partenaire qui recoit la primo-demande de secours (créateur du dossier).  Il est valorisé comme suit lors de sa création :  {pays}.{domaine}.{organisation}.{senderCaseId}  Il doit pouvoir être généré de façon décentralisée et ne présenter aucune ambiguïté.  Il doit être unique dans l&#39;ensemble des systèmes : le numéro de dossier fourni par celui qui génère l&#39;identifiant partagé doit donc être un numéro unique dans son système.</value>
        /*
        <example>example.json#/caseId</example>
        */
        [DataMember(Name = "caseId", IsRequired = true, EmitDefaultValue = true)]
        public string CaseId { get; set; }

        /// <summary>
        /// A valoriser avec l&#39;identifiant partagé unique de la ressource engagée , normé comme suit : {orgID}.R.{ID unique de la ressource partagée} Ou, uniquement dans le cas où un ID unique de ressource ne peut pas être garanti par l&#39;organisation propriétaire : {orgID}.R.{ID du dossier partagé}.{numéro d’ordre chronologique ressource}  N.B. Il s&#39;agit de l&#39;orgId de l&#39;organisation à qui appartient la ressource
        /// </summary>
        /// <value>A valoriser avec l&#39;identifiant partagé unique de la ressource engagée , normé comme suit : {orgID}.R.{ID unique de la ressource partagée} Ou, uniquement dans le cas où un ID unique de ressource ne peut pas être garanti par l&#39;organisation propriétaire : {orgID}.R.{ID du dossier partagé}.{numéro d’ordre chronologique ressource}  N.B. Il s&#39;agit de l&#39;orgId de l&#39;organisation à qui appartient la ressource</value>
        /*
        <example>example.json#/resourceId</example>
        */
        [DataMember(Name = "resourceId", IsRequired = true, EmitDefaultValue = true)]
        public string ResourceId { get; set; }

        /// <summary>
        /// Gets or Sets State
        /// </summary>
        [DataMember(Name = "state", IsRequired = true, EmitDefaultValue = true)]
        public State State { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourcesStatus {\n");
            sb.Append("  CaseId: ").Append(CaseId).Append("\n");
            sb.Append("  ResourceId: ").Append(ResourceId).Append("\n");
            sb.Append("  State: ").Append(State).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            if (this.CaseId != null) {
                // CaseId (string) pattern
                Regex regexCaseId = new Regex(@"^fr(\.[\w-]+){3,4}$", RegexOptions.CultureInvariant);
                if (!regexCaseId.Match(this.CaseId).Success)
                {
                    yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CaseId, must match a pattern of " + regexCaseId, new [] { "CaseId" });
                }
            }

            if (this.ResourceId != null) {
                // ResourceId (string) pattern
                Regex regexResourceId = new Regex(@"^([\w-]+\.){3,4}resource(\.[\w-]+){1,2}$", RegexOptions.CultureInvariant);
                if (!regexResourceId.Match(this.ResourceId).Success)
                {
                    yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ResourceId, must match a pattern of " + regexResourceId, new [] { "ResourceId" });
                }
            }

            yield break;
        }
    }

}
