/*
 * OpenAPI
 *
 * OpenAPI
 *
 * The version of the OpenAPI document: 0.0.1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = HubsanteModel/Technical.Client.OpenAPIDateConverter;

namespace HubsanteModel/Technical.Model
{
    /// <summary>
    /// TechnicalObject
    /// </summary>
    [DataContract(Name = "technicalObject")]
    public partial class TechnicalObject : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TechnicalObject" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TechnicalObject() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TechnicalObject" /> class.
        /// </summary>
        /// <param name="objectPropertyString">Object property string.</param>
        /// <param name="objectPropertyNumber">Object property number.</param>
        /// <param name="objectPropertyRequiredString">Required object property (required).</param>
        public TechnicalObject(string objectPropertyString = default(string), decimal objectPropertyNumber = default(decimal), string objectPropertyRequiredString = default(string))
        {
            // to ensure "objectPropertyRequiredString" is required (not null)
            if (objectPropertyRequiredString == null)
            {
                throw new ArgumentNullException("objectPropertyRequiredString is a required property for TechnicalObject and cannot be null");
            }
            this.ObjectPropertyRequiredString = objectPropertyRequiredString;
            this.ObjectPropertyString = objectPropertyString;
            this.ObjectPropertyNumber = objectPropertyNumber;
        }

        /// <summary>
        /// Object property string
        /// </summary>
        /// <value>Object property string</value>
        /*
        <example>example.json#/objectField/objectPropertyString</example>
        */
        [DataMember(Name = "objectPropertyString", EmitDefaultValue = false)]
        public string ObjectPropertyString { get; set; }

        /// <summary>
        /// Object property number
        /// </summary>
        /// <value>Object property number</value>
        [DataMember(Name = "objectPropertyNumber", EmitDefaultValue = false)]
        public decimal ObjectPropertyNumber { get; set; }

        /// <summary>
        /// Required object property
        /// </summary>
        /// <value>Required object property</value>
        /*
        <example>example.json#/objectField/objectPropertyRequiredString</example>
        */
        [DataMember(Name = "objectPropertyRequiredString", IsRequired = true, EmitDefaultValue = true)]
        public string ObjectPropertyRequiredString { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class TechnicalObject {\n");
            sb.Append("  ObjectPropertyString: ").Append(ObjectPropertyString).Append("\n");
            sb.Append("  ObjectPropertyNumber: ").Append(ObjectPropertyNumber).Append("\n");
            sb.Append("  ObjectPropertyRequiredString: ").Append(ObjectPropertyRequiredString).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
