=begin
#OpenAPI

#OpenAPI

The version of the OpenAPI document: 0.0.1

Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module Cisu
  class CreateCase
    # Identifiant partagé de l'affaire/dossier, généré une seule fois par le système du partenaire qui recoit la primo-demande de secours (créateur du dossier).  Il est valorisé comme suit lors de sa création :  {pays}.{domaine}.{organisation}.{senderCaseId}  Il doit pouvoir être généré de façon décentralisée et ne présenter aucune ambiguïté.  Il doit être unique dans l'ensemble des systèmes : le numéro de dossier fourni par celui qui génère l'identifiant partagé doit donc être un numéro unique dans son système.
    attr_accessor :case_id

    # A valoriser avec le numéro du dossier dans le SI de l'émetteur du message. 
    attr_accessor :sender_case_id

    # A valoriser avec le groupe date heure de création du dossier/affaire.  Spécificité 15-18 : A valoriser avec le groupe date heure de début de partage lié à la création de l'affaire (et donc de génération du caseId).  Lors de l'ajout d'une nouvelle alerte, la valeur de ce champ ne doit pas être modifiée.   L'indicateur de fuseau horaire Z ne doit pas être utilisé. Il doit être renseigné à la fin du processus de la  création de la première alerte.
    attr_accessor :creation

    # Indique le numéro de version du référentiel des nomenclatures des codes transmis.  Cela permet aux différents systèmes de s'assurer qu'ils utilisent la même version des codes de nomenclature que leurs partenaires.
    attr_accessor :reference_version

    attr_accessor :qualification

    attr_accessor :location

    attr_accessor :initial_alert

    attr_accessor :new_alert

    attr_accessor :freetext

    attr_accessor :additional_information

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'case_id' => :'caseId',
        :'sender_case_id' => :'senderCaseId',
        :'creation' => :'creation',
        :'reference_version' => :'referenceVersion',
        :'qualification' => :'qualification',
        :'location' => :'location',
        :'initial_alert' => :'initialAlert',
        :'new_alert' => :'newAlert',
        :'freetext' => :'freetext',
        :'additional_information' => :'additionalInformation'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'case_id' => :'String',
        :'sender_case_id' => :'String',
        :'creation' => :'Time',
        :'reference_version' => :'String',
        :'qualification' => :'Qualification',
        :'location' => :'Location',
        :'initial_alert' => :'Alert',
        :'new_alert' => :'Array<Alert>',
        :'freetext' => :'Array<String>',
        :'additional_information' => :'AdditionalInformation'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Cisu::CreateCase` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Cisu::CreateCase`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'case_id')
        self.case_id = attributes[:'case_id']
      else
        self.case_id = nil
      end

      if attributes.key?(:'sender_case_id')
        self.sender_case_id = attributes[:'sender_case_id']
      end

      if attributes.key?(:'creation')
        self.creation = attributes[:'creation']
      else
        self.creation = nil
      end

      if attributes.key?(:'reference_version')
        self.reference_version = attributes[:'reference_version']
      else
        self.reference_version = nil
      end

      if attributes.key?(:'qualification')
        self.qualification = attributes[:'qualification']
      else
        self.qualification = nil
      end

      if attributes.key?(:'location')
        self.location = attributes[:'location']
      else
        self.location = nil
      end

      if attributes.key?(:'initial_alert')
        self.initial_alert = attributes[:'initial_alert']
      end

      if attributes.key?(:'new_alert')
        if (value = attributes[:'new_alert']).is_a?(Array)
          self.new_alert = value
        end
      end

      if attributes.key?(:'freetext')
        if (value = attributes[:'freetext']).is_a?(Array)
          self.freetext = value
        end
      end

      if attributes.key?(:'additional_information')
        self.additional_information = attributes[:'additional_information']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @case_id.nil?
        invalid_properties.push('invalid value for "case_id", case_id cannot be nil.')
      end

      pattern = Regexp.new(/^fr(\.[\w-]+){3,4}$/)
      if @case_id !~ pattern
        invalid_properties.push("invalid value for \"case_id\", must conform to the pattern #{pattern}.")
      end

      if @creation.nil?
        invalid_properties.push('invalid value for "creation", creation cannot be nil.')
      end

      pattern = Regexp.new(/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}[\-+]\d{2}:\d{2}$/)
      if @creation !~ pattern
        invalid_properties.push("invalid value for \"creation\", must conform to the pattern #{pattern}.")
      end

      if @reference_version.nil?
        invalid_properties.push('invalid value for "reference_version", reference_version cannot be nil.')
      end

      if @qualification.nil?
        invalid_properties.push('invalid value for "qualification", qualification cannot be nil.')
      end

      if @location.nil?
        invalid_properties.push('invalid value for "location", location cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @case_id.nil?
      return false if @case_id !~ Regexp.new(/^fr(\.[\w-]+){3,4}$/)
      return false if @creation.nil?
      return false if @creation !~ Regexp.new(/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}[\-+]\d{2}:\d{2}$/)
      return false if @reference_version.nil?
      return false if @qualification.nil?
      return false if @location.nil?
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] case_id Value to be assigned
    def case_id=(case_id)
      if case_id.nil?
        fail ArgumentError, 'case_id cannot be nil'
      end

      pattern = Regexp.new(/^fr(\.[\w-]+){3,4}$/)
      if case_id !~ pattern
        fail ArgumentError, "invalid value for \"case_id\", must conform to the pattern #{pattern}."
      end

      @case_id = case_id
    end

    # Custom attribute writer method with validation
    # @param [Object] creation Value to be assigned
    def creation=(creation)
      if creation.nil?
        fail ArgumentError, 'creation cannot be nil'
      end

      pattern = Regexp.new(/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}[\-+]\d{2}:\d{2}$/)
      if creation !~ pattern
        fail ArgumentError, "invalid value for \"creation\", must conform to the pattern #{pattern}."
      end

      @creation = creation
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          case_id == o.case_id &&
          sender_case_id == o.sender_case_id &&
          creation == o.creation &&
          reference_version == o.reference_version &&
          qualification == o.qualification &&
          location == o.location &&
          initial_alert == o.initial_alert &&
          new_alert == o.new_alert &&
          freetext == o.freetext &&
          additional_information == o.additional_information
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [case_id, sender_case_id, creation, reference_version, qualification, location, initial_alert, new_alert, freetext, additional_information].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Cisu.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
