=begin
#OpenAPI

#OpenAPI

The version of the OpenAPI document: 0.0.1

Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module Health
  class CaseDetails
    # A valoriser avec l'état du dossier dans le système émetteur Spécificité 15-15 : peut être ignoré en réception, partagé à titre indicatif uniquement Spécificité 15-SMUR : à utiliser à minima pour transmettre le statut CLOTURE à la tablette
    attr_accessor :status

    # Décrit le type de professionnel médical à qui le dossier est attribué : médecin généraliste, médecin urgentiste etc.
    attr_accessor :attribution

    # Décrit la priorité de régulation médicale du dossier : P0, P1, P2, P3
    attr_accessor :priority

    # Décrit le niveau de soins global du dossier identifié au cours de l'acte de régulation médicale : s'il y a plusieurs niveaux de soins différents pour chaque patient, on indique ici le niveau le plus grave. cf.nomenclature associée.
    attr_accessor :care_level

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'status' => :'status',
        :'attribution' => :'attribution',
        :'priority' => :'priority',
        :'care_level' => :'careLevel'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'status' => :'String',
        :'attribution' => :'String',
        :'priority' => :'String',
        :'care_level' => :'String'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Health::CaseDetails` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Health::CaseDetails`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'attribution')
        self.attribution = attributes[:'attribution']
      end

      if attributes.key?(:'priority')
        self.priority = attributes[:'priority']
      end

      if attributes.key?(:'care_level')
        self.care_level = attributes[:'care_level']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      status_validator = EnumAttributeValidator.new('String', ["PROGRAM", "ACTIF", "ACHEVE", "VALIDE", "CLOTURE", "CLASSE", "ARCHIVE"])
      return false unless status_validator.valid?(@status)
      attribution_validator = EnumAttributeValidator.new('String', ["DRM", "DRM.MRU", "DRM.MRU.MU", "DRM.MRU.INDISPMU", "DRM.MRU.SSE", "DRM.MRU.PLANBLAN", "DRM.MRU.PCSAMU", "DRM.SPE", "DRM.SPE.DENT", "DRM.SPE.GERIA", "DRM.SPE.PEDIA", "DRM.SPE.OBST", "DRM.SPE.PSY", "DRM.SPE.TOXICOL", "DRM.SPE.AUTRESPE", "DRM.MRL", "DRM.MRL.MG", "DRM.MRL.INDISPMG", "DRM.MRL.ABSML", "DR", "DR.DREG", "DR.DREG.DRARM", "DR.DREG.DRDAC", "DR.DREG.DRMED", "DR.DREG.DRPHARMA", "DR.DREG.DRDENT", "DR.DREG.DRINFO", "DR.DREG.DOS-SIS", "DR.DREG.DOS-FDO", "D", "D.D-MALV", "D.D-MALV.ERR", "D.D-MALV.NRP", "D.D-MALV.MALV", "D.D-MALV.FAX", "D.D-MALV.ITERATIF", "D.D-IDENT", "D.D-IDENT.ADMIN", "D.D-IDENT.PERSO", "D.D-IDENT.AUTRE"])
      return false unless attribution_validator.valid?(@attribution)
      priority_validator = EnumAttributeValidator.new('String', ["P0", "P1", "P2", "P3", "NR"])
      return false unless priority_validator.valid?(@priority)
      care_level_validator = EnumAttributeValidator.new('String', ["R1", "R2", "R3", "R4"])
      return false unless care_level_validator.valid?(@care_level)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('String', ["PROGRAM", "ACTIF", "ACHEVE", "VALIDE", "CLOTURE", "CLASSE", "ARCHIVE"])
      unless validator.valid?(status)
        fail ArgumentError, "invalid value for \"status\", must be one of #{validator.allowable_values}."
      end
      @status = status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] attribution Object to be assigned
    def attribution=(attribution)
      validator = EnumAttributeValidator.new('String', ["DRM", "DRM.MRU", "DRM.MRU.MU", "DRM.MRU.INDISPMU", "DRM.MRU.SSE", "DRM.MRU.PLANBLAN", "DRM.MRU.PCSAMU", "DRM.SPE", "DRM.SPE.DENT", "DRM.SPE.GERIA", "DRM.SPE.PEDIA", "DRM.SPE.OBST", "DRM.SPE.PSY", "DRM.SPE.TOXICOL", "DRM.SPE.AUTRESPE", "DRM.MRL", "DRM.MRL.MG", "DRM.MRL.INDISPMG", "DRM.MRL.ABSML", "DR", "DR.DREG", "DR.DREG.DRARM", "DR.DREG.DRDAC", "DR.DREG.DRMED", "DR.DREG.DRPHARMA", "DR.DREG.DRDENT", "DR.DREG.DRINFO", "DR.DREG.DOS-SIS", "DR.DREG.DOS-FDO", "D", "D.D-MALV", "D.D-MALV.ERR", "D.D-MALV.NRP", "D.D-MALV.MALV", "D.D-MALV.FAX", "D.D-MALV.ITERATIF", "D.D-IDENT", "D.D-IDENT.ADMIN", "D.D-IDENT.PERSO", "D.D-IDENT.AUTRE"])
      unless validator.valid?(attribution)
        fail ArgumentError, "invalid value for \"attribution\", must be one of #{validator.allowable_values}."
      end
      @attribution = attribution
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] priority Object to be assigned
    def priority=(priority)
      validator = EnumAttributeValidator.new('String', ["P0", "P1", "P2", "P3", "NR"])
      unless validator.valid?(priority)
        fail ArgumentError, "invalid value for \"priority\", must be one of #{validator.allowable_values}."
      end
      @priority = priority
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] care_level Object to be assigned
    def care_level=(care_level)
      validator = EnumAttributeValidator.new('String', ["R1", "R2", "R3", "R4"])
      unless validator.valid?(care_level)
        fail ArgumentError, "invalid value for \"care_level\", must be one of #{validator.allowable_values}."
      end
      @care_level = care_level
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          status == o.status &&
          attribution == o.attribution &&
          priority == o.priority &&
          care_level == o.care_level
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [status, attribution, priority, care_level].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Health.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
