=begin
#OpenAPI

#OpenAPI

The version of the OpenAPI document: 0.0.1

Generated by: https://openapi-generator.tech
Generator version: 7.10.0

=end

require 'date'
require 'time'

module Resourcesinfo
  class Resource
    # A valoriser avec la date et heure d'engagement de la ressource/du vecteur
    attr_accessor :datetime

    # A valoriser avec l'identifiant partagé unique de la ressource engagée, normé comme suit : {orgID}.resource.{ID unique de la ressource partagée} OU - uniquement dans le cas où un ID unique de ressource ne peut pas être garanti par l'organisation propriétaire : {orgID}.resource.{sendercaseId}.{n° d’ordre chronologique de la ressource}
    attr_accessor :resource_id

    # A valoriser avec l'identifiant unique partagé de la demande de ressource (si la ressource a été engagée suite à une demande de ressource), normé comme suit : {orgID}.request.{ID unique de la demande dans le système émetteur} OU - si un ID unique de la demande n'était pas disponible :  {OrgId émetteur}.request.{senderCaseId}.{numéro d’ordre chronologique}
    attr_accessor :request_id

    # A valoriser avec le numéro de mission unique du central d’appel (PSAP, …) qui a déclenché le vecteur
    attr_accessor :mission_id

    # A valoriser avec l'identifiant de l'organisation à laquelle appartient la ressource, normé comme suit :  {pays}.{domaine}.{organisation}
    attr_accessor :org_id

    # Identifiant partagé du patient qui est transporté. Ce n'est à remplir que lorsque l'on sait quel vecteur transporte quel patient.  Il est valorisé comme suit lors de sa création :  {OrgId émetteur}.patient.{n°patient unique dans le système émetteur}  OU, si un n°patient unique n'existe pas dans le système émetteur : {ID émetteur}.{senderCaseId}.patient.{numéro d’ordre chronologique au dossier}
    attr_accessor :patient_id

    # A valoriser avec le lieu de garage principal
    attr_accessor :center_name

    # A valoriser avec le type de vecteur mobilisé : cf. nomenclature associée
    attr_accessor :vehicle_type

    # A valoriser avec le nom donné à la ressource par l’organisation d’appartenance
    attr_accessor :name

    # A valoriser avec le code INSEE de la commune du centre d'affectation
    attr_accessor :center_city

    attr_accessor :team

    attr_accessor :state

    attr_accessor :contact

    attr_accessor :freetext

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'datetime' => :'datetime',
        :'resource_id' => :'resourceId',
        :'request_id' => :'requestId',
        :'mission_id' => :'missionId',
        :'org_id' => :'orgId',
        :'patient_id' => :'patientId',
        :'center_name' => :'centerName',
        :'vehicle_type' => :'vehicleType',
        :'name' => :'name',
        :'center_city' => :'centerCity',
        :'team' => :'team',
        :'state' => :'state',
        :'contact' => :'contact',
        :'freetext' => :'freetext'
      }
    end

    # Returns all the JSON keys this model knows about
    def self.acceptable_attributes
      attribute_map.values
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'datetime' => :'Time',
        :'resource_id' => :'String',
        :'request_id' => :'String',
        :'mission_id' => :'String',
        :'org_id' => :'String',
        :'patient_id' => :'String',
        :'center_name' => :'String',
        :'vehicle_type' => :'String',
        :'name' => :'String',
        :'center_city' => :'String',
        :'team' => :'Team',
        :'state' => :'Array<State>',
        :'contact' => :'Contact',
        :'freetext' => :'Array<String>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Resourcesinfo::Resource` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Resourcesinfo::Resource`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'datetime')
        self.datetime = attributes[:'datetime']
      else
        self.datetime = nil
      end

      if attributes.key?(:'resource_id')
        self.resource_id = attributes[:'resource_id']
      else
        self.resource_id = nil
      end

      if attributes.key?(:'request_id')
        self.request_id = attributes[:'request_id']
      end

      if attributes.key?(:'mission_id')
        self.mission_id = attributes[:'mission_id']
      end

      if attributes.key?(:'org_id')
        self.org_id = attributes[:'org_id']
      end

      if attributes.key?(:'patient_id')
        self.patient_id = attributes[:'patient_id']
      end

      if attributes.key?(:'center_name')
        self.center_name = attributes[:'center_name']
      end

      if attributes.key?(:'vehicle_type')
        self.vehicle_type = attributes[:'vehicle_type']
      else
        self.vehicle_type = nil
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'center_city')
        self.center_city = attributes[:'center_city']
      end

      if attributes.key?(:'team')
        self.team = attributes[:'team']
      end

      if attributes.key?(:'state')
        if (value = attributes[:'state']).is_a?(Array)
          self.state = value
        end
      end

      if attributes.key?(:'contact')
        self.contact = attributes[:'contact']
      end

      if attributes.key?(:'freetext')
        if (value = attributes[:'freetext']).is_a?(Array)
          self.freetext = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      warn '[DEPRECATED] the `list_invalid_properties` method is obsolete'
      invalid_properties = Array.new
      if @datetime.nil?
        invalid_properties.push('invalid value for "datetime", datetime cannot be nil.')
      end

      pattern = Regexp.new(/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}[\-+]\d{2}:\d{2}$/)
      if @datetime !~ pattern
        invalid_properties.push("invalid value for \"datetime\", must conform to the pattern #{pattern}.")
      end

      if @resource_id.nil?
        invalid_properties.push('invalid value for "resource_id", resource_id cannot be nil.')
      end

      pattern = Regexp.new(/^([\w-]+\.){3,4}resource(\.[\w-]+){1,2}$/)
      if @resource_id !~ pattern
        invalid_properties.push("invalid value for \"resource_id\", must conform to the pattern #{pattern}.")
      end

      pattern = Regexp.new(/^([\w-]+\.){3,4}request(\.[\w-]+){1,2}$/)
      if !@request_id.nil? && @request_id !~ pattern
        invalid_properties.push("invalid value for \"request_id\", must conform to the pattern #{pattern}.")
      end

      if @vehicle_type.nil?
        invalid_properties.push('invalid value for "vehicle_type", vehicle_type cannot be nil.')
      end

      pattern = Regexp.new(/^[0-9]{5}$/)
      if !@center_city.nil? && @center_city !~ pattern
        invalid_properties.push("invalid value for \"center_city\", must conform to the pattern #{pattern}.")
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      warn '[DEPRECATED] the `valid?` method is obsolete'
      return false if @datetime.nil?
      return false if @datetime !~ Regexp.new(/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}[\-+]\d{2}:\d{2}$/)
      return false if @resource_id.nil?
      return false if @resource_id !~ Regexp.new(/^([\w-]+\.){3,4}resource(\.[\w-]+){1,2}$/)
      return false if !@request_id.nil? && @request_id !~ Regexp.new(/^([\w-]+\.){3,4}request(\.[\w-]+){1,2}$/)
      return false if @vehicle_type.nil?
      vehicle_type_validator = EnumAttributeValidator.new('String', ["AASC", "AASC.VLSC", "AASC.VPSP", "AASC.AUTRESC", "AUTREVEC", "AUTREVEC.APIED", "AUTREVEC.AVION", "AUTREVEC.PERSO", "AUTREVEC.TAXI", "AUTREVEC.TRAIN", "AUTREVEC.TRANSP", "AUTREVEC.AUTRE", "AUTREVEC.AUTRETRA", "FSI", "FSI.HELIFSI", "FSI.VLFSI", "FSI.FFSI", "FSI.VHFSI", "LIB", "LIB.MEDV", "LIB.INF", "LIB.AUTREPRO", "SIS", "SIS.DRAGON", "SIS.AVSC", "SIS.FEUSIS", "SIS.GRIMP", "SIS.NAVISIS", "SIS.PCSIS", "SIS.SRSIS", "SIS.VCH", "SIS.VLCG", "SIS.VLISP", "SIS.VLMSP", "SIS.VLSIS", "SIS.VPL", "SIS.VPMA", "SIS.VR", "SIS.VSAV", "SIS.MOYSSE", "SIS.AUTRESIS", "SMUR", "SMUR.VLM", "SMUR.VL", "SMUR.PSM1", "SMUR.PSM2", "SMUR.PSM3", "SMUR.PSMP", "SMUR.VPC", "SMUR.AR", "SMUR.AR-BAR", "SMUR.AR-PED", "SMUR.HELISMUR", "SMUR.HELISAN", "SMUR.AVSMUR", "SMUR.AVSAN", "SMUR.NAVISMUR", "TSU", "TSU.VSL", "TSU.AMB-GV", "TSU.AMB-PV", "TSU.AMB-BAR", "TSU.AMB"])
      return false unless vehicle_type_validator.valid?(@vehicle_type)
      return false if !@center_city.nil? && @center_city !~ Regexp.new(/^[0-9]{5}$/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] datetime Value to be assigned
    def datetime=(datetime)
      if datetime.nil?
        fail ArgumentError, 'datetime cannot be nil'
      end

      pattern = Regexp.new(/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}[\-+]\d{2}:\d{2}$/)
      if datetime !~ pattern
        fail ArgumentError, "invalid value for \"datetime\", must conform to the pattern #{pattern}."
      end

      @datetime = datetime
    end

    # Custom attribute writer method with validation
    # @param [Object] resource_id Value to be assigned
    def resource_id=(resource_id)
      if resource_id.nil?
        fail ArgumentError, 'resource_id cannot be nil'
      end

      pattern = Regexp.new(/^([\w-]+\.){3,4}resource(\.[\w-]+){1,2}$/)
      if resource_id !~ pattern
        fail ArgumentError, "invalid value for \"resource_id\", must conform to the pattern #{pattern}."
      end

      @resource_id = resource_id
    end

    # Custom attribute writer method with validation
    # @param [Object] request_id Value to be assigned
    def request_id=(request_id)
      if request_id.nil?
        fail ArgumentError, 'request_id cannot be nil'
      end

      pattern = Regexp.new(/^([\w-]+\.){3,4}request(\.[\w-]+){1,2}$/)
      if request_id !~ pattern
        fail ArgumentError, "invalid value for \"request_id\", must conform to the pattern #{pattern}."
      end

      @request_id = request_id
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] vehicle_type Object to be assigned
    def vehicle_type=(vehicle_type)
      validator = EnumAttributeValidator.new('String', ["AASC", "AASC.VLSC", "AASC.VPSP", "AASC.AUTRESC", "AUTREVEC", "AUTREVEC.APIED", "AUTREVEC.AVION", "AUTREVEC.PERSO", "AUTREVEC.TAXI", "AUTREVEC.TRAIN", "AUTREVEC.TRANSP", "AUTREVEC.AUTRE", "AUTREVEC.AUTRETRA", "FSI", "FSI.HELIFSI", "FSI.VLFSI", "FSI.FFSI", "FSI.VHFSI", "LIB", "LIB.MEDV", "LIB.INF", "LIB.AUTREPRO", "SIS", "SIS.DRAGON", "SIS.AVSC", "SIS.FEUSIS", "SIS.GRIMP", "SIS.NAVISIS", "SIS.PCSIS", "SIS.SRSIS", "SIS.VCH", "SIS.VLCG", "SIS.VLISP", "SIS.VLMSP", "SIS.VLSIS", "SIS.VPL", "SIS.VPMA", "SIS.VR", "SIS.VSAV", "SIS.MOYSSE", "SIS.AUTRESIS", "SMUR", "SMUR.VLM", "SMUR.VL", "SMUR.PSM1", "SMUR.PSM2", "SMUR.PSM3", "SMUR.PSMP", "SMUR.VPC", "SMUR.AR", "SMUR.AR-BAR", "SMUR.AR-PED", "SMUR.HELISMUR", "SMUR.HELISAN", "SMUR.AVSMUR", "SMUR.AVSAN", "SMUR.NAVISMUR", "TSU", "TSU.VSL", "TSU.AMB-GV", "TSU.AMB-PV", "TSU.AMB-BAR", "TSU.AMB"])
      unless validator.valid?(vehicle_type)
        fail ArgumentError, "invalid value for \"vehicle_type\", must be one of #{validator.allowable_values}."
      end
      @vehicle_type = vehicle_type
    end

    # Custom attribute writer method with validation
    # @param [Object] center_city Value to be assigned
    def center_city=(center_city)
      if center_city.nil?
        fail ArgumentError, 'center_city cannot be nil'
      end

      pattern = Regexp.new(/^[0-9]{5}$/)
      if center_city !~ pattern
        fail ArgumentError, "invalid value for \"center_city\", must conform to the pattern #{pattern}."
      end

      @center_city = center_city
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          datetime == o.datetime &&
          resource_id == o.resource_id &&
          request_id == o.request_id &&
          mission_id == o.mission_id &&
          org_id == o.org_id &&
          patient_id == o.patient_id &&
          center_name == o.center_name &&
          vehicle_type == o.vehicle_type &&
          name == o.name &&
          center_city == o.center_city &&
          team == o.team &&
          state == o.state &&
          contact == o.contact &&
          freetext == o.freetext
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [datetime, resource_id, request_id, mission_id, org_id, patient_id, center_name, vehicle_type, name, center_city, team, state, contact, freetext].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      attributes = attributes.transform_keys(&:to_sym)
      transformed_hash = {}
      openapi_types.each_pair do |key, type|
        if attributes.key?(attribute_map[key]) && attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = nil
        elsif type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[attribute_map[key]].is_a?(Array)
            transformed_hash["#{key}"] = attributes[attribute_map[key]].map { |v| _deserialize($1, v) }
          end
        elsif !attributes[attribute_map[key]].nil?
          transformed_hash["#{key}"] = _deserialize(type, attributes[attribute_map[key]])
        end
      end
      new(transformed_hash)
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def self._deserialize(type, value)
      case type.to_sym
      when :Time
        Time.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        # models (e.g. Pet) or oneOf
        klass = Resourcesinfo.const_get(type)
        klass.respond_to?(:openapi_any_of) || klass.respond_to?(:openapi_one_of) ? klass.build(value) : klass.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
