/**
 * Copyright © 2023-2025 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.emsi;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;

/**
 * Reference
 */
@JsonPropertyOrder({Reference.JSON_PROPERTY_O_R_G_I_D,
                    Reference.JSON_PROPERTY_O_T_H_E_R_E_V_E_N_T_I_D})
@JsonTypeName("reference")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class Reference {
  public static final String JSON_PROPERTY_O_R_G_I_D = "ORG_ID";
  private String ORG_ID;

  public static final String JSON_PROPERTY_O_T_H_E_R_E_V_E_N_T_I_D =
      "OTHER_EVENT_ID";
  private List<String> OTHER_EVENT_ID = new ArrayList<>();

  public Reference() {}

  public Reference ORG_ID(String ORG_ID) {

    this.ORG_ID = ORG_ID;
    return this;
  }

  /**
   * Le format est le suivant {pays}.{domaine}.{organisation}.{structure
   *interne}*.{unité fonctionnelle}*. NB : ce champ (EVENT.REFERENCE.ORG_ID) ne
   *peut pas être le même que le champ CONTEXT.LINK.ID ou EVENT.ID
   * @return ORG_ID
   **/
  @JsonProperty(JSON_PROPERTY_O_R_G_I_D)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getORGID() {
    return ORG_ID;
  }

  @JsonProperty(JSON_PROPERTY_O_R_G_I_D)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setORGID(String ORG_ID) {
    this.ORG_ID = ORG_ID;
  }

  public Reference OTHER_EVENT_ID(List<String> OTHER_EVENT_ID) {

    this.OTHER_EVENT_ID = OTHER_EVENT_ID;
    return this;
  }

  public Reference addOTHEREVENTIDItem(String OTHER_EVENT_IDItem) {
    if (this.OTHER_EVENT_ID == null) {
      this.OTHER_EVENT_ID = new ArrayList<>();
    }
    this.OTHER_EVENT_ID.add(OTHER_EVENT_IDItem);
    return this;
  }

  /**
   * Get OTHER_EVENT_ID
   * @return OTHER_EVENT_ID
   **/
  @JsonProperty(JSON_PROPERTY_O_T_H_E_R_E_V_E_N_T_I_D)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<String> getOTHEREVENTID() {
    return OTHER_EVENT_ID;
  }

  @JacksonXmlElementWrapper(useWrapping = false)

  @JsonProperty(JSON_PROPERTY_O_T_H_E_R_E_V_E_N_T_I_D)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setOTHEREVENTID(List<String> OTHER_EVENT_ID) {
    if (OTHER_EVENT_ID == null) {
      return;
    }
    if (this.OTHER_EVENT_ID == null) {
      this.OTHER_EVENT_ID = new ArrayList<>();
    }
    this.OTHER_EVENT_ID.addAll(OTHER_EVENT_ID);
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Reference reference = (Reference)o;
    return Objects.equals(this.ORG_ID, reference.ORG_ID) &&
        Objects.equals(this.OTHER_EVENT_ID, reference.OTHER_EVENT_ID);
  }

  @Override
  public int hashCode() {
    return Objects.hash(ORG_ID, OTHER_EVENT_ID);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Reference {\n");
    sb.append("    ORG_ID: ").append(toIndentedString(ORG_ID)).append("\n");
    sb.append("    OTHER_EVENT_ID: ")
        .append(toIndentedString(OTHER_EVENT_ID))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
