/**
 * Copyright © 2023-2025 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.health;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import com.hubsante.model.health.MainDiagnosis;
import com.hubsante.model.health.OtherDiagnosis;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;

/**
 * Hypothesis
 */
@JsonPropertyOrder({Hypothesis.JSON_PROPERTY_MAIN_DIAGNOSIS,
                    Hypothesis.JSON_PROPERTY_OTHER_DIAGNOSIS})
@JsonTypeName("hypothesis")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class Hypothesis {
  public static final String JSON_PROPERTY_MAIN_DIAGNOSIS = "mainDiagnosis";
  private MainDiagnosis mainDiagnosis;

  public static final String JSON_PROPERTY_OTHER_DIAGNOSIS = "otherDiagnosis";
  private List<OtherDiagnosis> otherDiagnosis;

  public Hypothesis() {}

  public Hypothesis mainDiagnosis(MainDiagnosis mainDiagnosis) {

    this.mainDiagnosis = mainDiagnosis;
    return this;
  }

  /**
   * Get mainDiagnosis
   * @return mainDiagnosis
   **/
  @JsonProperty(JSON_PROPERTY_MAIN_DIAGNOSIS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public MainDiagnosis getMainDiagnosis() {
    return mainDiagnosis;
  }

  @JsonProperty(JSON_PROPERTY_MAIN_DIAGNOSIS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setMainDiagnosis(MainDiagnosis mainDiagnosis) {
    this.mainDiagnosis = mainDiagnosis;
  }

  public Hypothesis otherDiagnosis(List<OtherDiagnosis> otherDiagnosis) {

    this.otherDiagnosis = otherDiagnosis;
    return this;
  }

  public Hypothesis addOtherDiagnosisItem(OtherDiagnosis otherDiagnosisItem) {
    if (this.otherDiagnosis == null) {
      this.otherDiagnosis = new ArrayList<>();
    }
    this.otherDiagnosis.add(otherDiagnosisItem);
    return this;
  }

  /**
   * Get otherDiagnosis
   * @return otherDiagnosis
   **/
  @JsonProperty(JSON_PROPERTY_OTHER_DIAGNOSIS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public List<OtherDiagnosis> getOtherDiagnosis() {
    return otherDiagnosis;
  }

  @JacksonXmlElementWrapper(useWrapping = false)

  @JsonProperty(JSON_PROPERTY_OTHER_DIAGNOSIS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setOtherDiagnosis(List<OtherDiagnosis> otherDiagnosis) {
    if (otherDiagnosis == null) {
      return;
    }
    if (this.otherDiagnosis == null) {
      this.otherDiagnosis = new ArrayList<>();
    }
    this.otherDiagnosis.addAll(otherDiagnosis);
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Hypothesis hypothesis = (Hypothesis)o;
    return Objects.equals(this.mainDiagnosis, hypothesis.mainDiagnosis) &&
        Objects.equals(this.otherDiagnosis, hypothesis.otherDiagnosis);
  }

  @Override
  public int hashCode() {
    return Objects.hash(mainDiagnosis, otherDiagnosis);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Hypothesis {\n");
    sb.append("    mainDiagnosis: ")
        .append(toIndentedString(mainDiagnosis))
        .append("\n");
    sb.append("    otherDiagnosis: ")
        .append(toIndentedString(otherDiagnosis))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
