/**
 * Copyright © 2023-2025 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.interventionreport;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import com.hubsante.model.interventionreport.Evaluation;
import com.hubsante.model.interventionreport.Patient;
import com.hubsante.model.interventionreport.Redactor;
import java.time.OffsetDateTime;
import java.util.Arrays;
import java.util.Arrays;
import java.util.Objects;

/**
 * InterventionReport
 */
@JsonPropertyOrder({InterventionReport.JSON_PROPERTY_CASE_ID,
                    InterventionReport.JSON_PROPERTY_REPORT_ID,
                    InterventionReport.JSON_PROPERTY_REDACTOR,
                    InterventionReport.JSON_PROPERTY_CREATION,
                    InterventionReport.JSON_PROPERTY_PATIENT,
                    InterventionReport.JSON_PROPERTY_EVALUATION})
@JsonTypeName("interventionReport")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class InterventionReport {
  @JacksonXmlProperty(isAttribute = true)
  String xmlns = "urn:emergency:eda:1.9:interventionreport";
  public static final String JSON_PROPERTY_CASE_ID = "caseId";
  private String caseId;

  public static final String JSON_PROPERTY_REPORT_ID = "reportId";
  private String reportId;

  public static final String JSON_PROPERTY_REDACTOR = "redactor";
  private Redactor redactor;

  public static final String JSON_PROPERTY_CREATION = "creation";
  private OffsetDateTime creation;

  public static final String JSON_PROPERTY_PATIENT = "patient";
  private Patient patient;

  public static final String JSON_PROPERTY_EVALUATION = "evaluation";
  private Evaluation evaluation;

  public InterventionReport() {}

  public InterventionReport caseId(String caseId) {

    this.caseId = caseId;
    return this;
  }

  /**
   * Identifiant partagé du dossier, généré une seule fois par le système du
   *partenaire qui recoit la primo-demande de secours (créateur du dossier).  Il
   *est valorisé comme suit lors de sa création :
   *{pays}.{domaine}.{organisation}.{senderCaseId}  Il doit pouvoir être généré
   *de façon décentralisée et ne présenter aucune ambiguïté.  Il doit être
   *unique dans l&#39;ensemble des systèmes : le numéro de dossier fourni par
   *celui qui génère l&#39;identifiant partagé doit donc être un numéro unique
   *dans son système.
   * @return caseId
   **/
  @JsonProperty(JSON_PROPERTY_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getCaseId() {
    return caseId;
  }

  @JsonProperty(JSON_PROPERTY_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setCaseId(String caseId) {
    this.caseId = caseId;
  }

  public InterventionReport reportId(String reportId) {

    this.reportId = reportId;
    return this;
  }

  /**
   * Identifiant du bilan du logiciel SMUR
   * @return reportId
   **/
  @JsonProperty(JSON_PROPERTY_REPORT_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getReportId() {
    return reportId;
  }

  @JsonProperty(JSON_PROPERTY_REPORT_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setReportId(String reportId) {
    this.reportId = reportId;
  }

  public InterventionReport redactor(Redactor redactor) {

    this.redactor = redactor;
    return this;
  }

  /**
   * Get redactor
   * @return redactor
   **/
  @JsonProperty(JSON_PROPERTY_REDACTOR)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public Redactor getRedactor() {
    return redactor;
  }

  @JsonProperty(JSON_PROPERTY_REDACTOR)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setRedactor(Redactor redactor) {
    this.redactor = redactor;
  }

  public InterventionReport creation(OffsetDateTime creation) {

    this.creation = creation;
    return this;
  }

  /**
   * s&#39;exprime au format ISO 8601 YYY-MM-DDThh:mm:ss
   * @return creation
   **/
  @JsonProperty(JSON_PROPERTY_CREATION)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public OffsetDateTime getCreation() {
    return creation;
  }

  @JsonProperty(JSON_PROPERTY_CREATION)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setCreation(OffsetDateTime creation) {
    this.creation = creation;
  }

  public InterventionReport patient(Patient patient) {

    this.patient = patient;
    return this;
  }

  /**
   * Get patient
   * @return patient
   **/
  @JsonProperty(JSON_PROPERTY_PATIENT)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public Patient getPatient() {
    return patient;
  }

  @JsonProperty(JSON_PROPERTY_PATIENT)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setPatient(Patient patient) {
    this.patient = patient;
  }

  public InterventionReport evaluation(Evaluation evaluation) {

    this.evaluation = evaluation;
    return this;
  }

  /**
   * Get evaluation
   * @return evaluation
   **/
  @JsonProperty(JSON_PROPERTY_EVALUATION)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Evaluation getEvaluation() {
    return evaluation;
  }

  @JsonProperty(JSON_PROPERTY_EVALUATION)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setEvaluation(Evaluation evaluation) {
    this.evaluation = evaluation;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InterventionReport interventionReport = (InterventionReport)o;
    return Objects.equals(this.caseId, interventionReport.caseId) &&
        Objects.equals(this.reportId, interventionReport.reportId) &&
        Objects.equals(this.redactor, interventionReport.redactor) &&
        Objects.equals(this.creation, interventionReport.creation) &&
        Objects.equals(this.patient, interventionReport.patient) &&
        Objects.equals(this.evaluation, interventionReport.evaluation);
  }

  @Override
  public int hashCode() {
    return Objects.hash(caseId, reportId, redactor, creation, patient,
                        evaluation);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InterventionReport {\n");
    sb.append("    caseId: ").append(toIndentedString(caseId)).append("\n");
    sb.append("    reportId: ").append(toIndentedString(reportId)).append("\n");
    sb.append("    redactor: ").append(toIndentedString(redactor)).append("\n");
    sb.append("    creation: ").append(toIndentedString(creation)).append("\n");
    sb.append("    patient: ").append(toIndentedString(patient)).append("\n");
    sb.append("    evaluation: ")
        .append(toIndentedString(evaluation))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
