/**
 * Copyright © 2023-2025 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.interventionreport;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import java.util.Arrays;
import java.util.Arrays;
import java.util.Objects;

/**
 * Vital
 */
@JsonPropertyOrder({Vital.JSON_PROPERTY_TYPE, Vital.JSON_PROPERTY_VALUE,
                    Vital.JSON_PROPERTY_PRECISION})
@JsonTypeName("vital")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class Vital {

  /**
   * Permet d&#39;indiquer le type de constante associé à la valeur envoyée
   */
  public enum TypeEnum {
    FREQUENCE_CARDIAQUE("FREQUENCE_CARDIAQUE"),

    PRESSION_ARTERIELLE("PRESSION_ARTERIELLE"),

    SATURATION_OXYGENE("SATURATION_OXYGENE"),

    FREQUENCE_RESPIRATOIRE("FREQUENCE_RESPIRATOIRE"),

    TEMPERATURE("TEMPERATURE"),

    HEMOGLOCOTEST("HEMOGLOCOTEST"),

    GLASGOW("GLASGOW");

    private String value;

    TypeEnum(String value) { this.value = value; }

    @JsonValue
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    @JsonCreator
    public static TypeEnum fromValue(String value) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }
  }

  public static final String JSON_PROPERTY_TYPE = "type";
  private TypeEnum type;

  public static final String JSON_PROPERTY_VALUE = "value";
  private String value;

  public static final String JSON_PROPERTY_PRECISION = "precision";
  private String precision;

  public Vital() {}

  public Vital type(TypeEnum type) {

    this.type = type;
    return this;
  }

  /**
   * Permet d&#39;indiquer le type de constante associé à la valeur envoyée
   * @return type
   **/
  @JsonProperty(JSON_PROPERTY_TYPE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public TypeEnum getType() {
    return type;
  }

  @JsonProperty(JSON_PROPERTY_TYPE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setType(TypeEnum type) {
    this.type = type;
  }

  public Vital value(String value) {

    this.value = value;
    return this;
  }

  /**
   * Indique la valeur de la dernière constante prise
   * @return value
   **/
  @JsonProperty(JSON_PROPERTY_VALUE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getValue() {
    return value;
  }

  @JsonProperty(JSON_PROPERTY_VALUE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setValue(String value) {
    this.value = value;
  }

  public Vital precision(String precision) {

    this.precision = precision;
    return this;
  }

  /**
   * Permet d&#39;apporter des précisions sur la constante prise (ex. le débit
   *d&#39;oxygène lors de la prise de constante de saturation en oxygène)
   * @return precision
   **/
  @JsonProperty(JSON_PROPERTY_PRECISION)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getPrecision() {
    return precision;
  }

  @JsonProperty(JSON_PROPERTY_PRECISION)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setPrecision(String precision) {
    this.precision = precision;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Vital vital = (Vital)o;
    return Objects.equals(this.type, vital.type) &&
        Objects.equals(this.value, vital.value) &&
        Objects.equals(this.precision, vital.precision);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, value, precision);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Vital {\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    value: ").append(toIndentedString(value)).append("\n");
    sb.append("    precision: ")
        .append(toIndentedString(precision))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
