/**
 * Copyright © 2023-2025 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.resources.status;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import com.hubsante.model.resources.status.State;
import java.util.Arrays;
import java.util.Arrays;
import java.util.Objects;

/**
 * ResourcesStatus
 */
@JsonPropertyOrder({ResourcesStatus.JSON_PROPERTY_CASE_ID,
                    ResourcesStatus.JSON_PROPERTY_RESOURCE_ID,
                    ResourcesStatus.JSON_PROPERTY_STATE})
@JsonTypeName("resourcesStatus")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class ResourcesStatus {
  @JacksonXmlProperty(isAttribute = true)
  String xmlns = "urn:emergency:eda:1.9:resourcesstatus";
  public static final String JSON_PROPERTY_CASE_ID = "caseId";
  private String caseId;

  public static final String JSON_PROPERTY_RESOURCE_ID = "resourceId";
  private String resourceId;

  public static final String JSON_PROPERTY_STATE = "state";
  private State state;

  public ResourcesStatus() {}

  public ResourcesStatus caseId(String caseId) {

    this.caseId = caseId;
    return this;
  }

  /**
   * A valoriser avec l&#39;identifiant partagé de l&#39;affaire/dossier, généré
   *une seule fois par le système du partenaire qui recoit la primo-demande de
   *secours (créateur du dossier).  Il est valorisé comme suit lors de sa
   *création :  {pays}.{domaine}.{organisation}.{senderCaseId}  Il doit pouvoir
   *être généré de façon décentralisée et ne présenter aucune ambiguïté.  Il
   *doit être unique dans l&#39;ensemble des systèmes : le numéro de dossier
   *fourni par celui qui génère l&#39;identifiant partagé doit donc être un
   *numéro unique dans son système.
   * @return caseId
   **/
  @JsonProperty(JSON_PROPERTY_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getCaseId() {
    return caseId;
  }

  @JsonProperty(JSON_PROPERTY_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setCaseId(String caseId) {
    this.caseId = caseId;
  }

  public ResourcesStatus resourceId(String resourceId) {

    this.resourceId = resourceId;
    return this;
  }

  /**
   * A valoriser avec l&#39;identifiant partagé unique de la ressource engagée ,
   *normé comme suit : {orgID}.R.{ID unique de la ressource partagée} Ou,
   *uniquement dans le cas où un ID unique de ressource ne peut pas être garanti
   *par l&#39;organisation propriétaire : {orgID}.R.{ID du dossier
   *partagé}.{numéro d’ordre chronologique ressource}  N.B. Il s&#39;agit de
   *l&#39;orgId de l&#39;organisation à qui appartient la ressource
   * @return resourceId
   **/
  @JsonProperty(JSON_PROPERTY_RESOURCE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public String getResourceId() {
    return resourceId;
  }

  @JsonProperty(JSON_PROPERTY_RESOURCE_ID)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setResourceId(String resourceId) {
    this.resourceId = resourceId;
  }

  public ResourcesStatus state(State state) {

    this.state = state;
    return this;
  }

  /**
   * Get state
   * @return state
   **/
  @JsonProperty(JSON_PROPERTY_STATE)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)

  public State getState() {
    return state;
  }

  @JsonProperty(JSON_PROPERTY_STATE)
  @JsonInclude(value = JsonInclude.Include.ALWAYS)
  public void setState(State state) {
    this.state = state;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ResourcesStatus resourcesStatus = (ResourcesStatus)o;
    return Objects.equals(this.caseId, resourcesStatus.caseId) &&
        Objects.equals(this.resourceId, resourcesStatus.resourceId) &&
        Objects.equals(this.state, resourcesStatus.state);
  }

  @Override
  public int hashCode() {
    return Objects.hash(caseId, resourceId, state);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ResourcesStatus {\n");
    sb.append("    caseId: ").append(toIndentedString(caseId)).append("\n");
    sb.append("    resourceId: ")
        .append(toIndentedString(resourceId))
        .append("\n");
    sb.append("    state: ").append(toIndentedString(state)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
