/**
 * Copyright © 2023-2025 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.rpis;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import java.time.OffsetDateTime;
import java.util.Arrays;
import java.util.Arrays;
import java.util.Objects;

/**
 * Event
 */
@JsonPropertyOrder(
    {Event.JSON_PROPERTY_ORG_ID, Event.JSON_PROPERTY_SENDER_CASE_ID,
     Event.JSON_PROPERTY_CREATION_DATE, Event.JSON_PROPERTY_DECISION_DATE,
     Event.JSON_PROPERTY_RESSOURCE_FINESS_LEGAL,
     Event.JSON_PROPERTY_RESSOURCE_FINESS_GEO,
     Event.JSON_PROPERTY_RESSOURCE_STRUCTURE})
@JsonTypeName("event")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class Event {
  public static final String JSON_PROPERTY_ORG_ID = "orgId";
  private String orgId;

  public static final String JSON_PROPERTY_SENDER_CASE_ID = "senderCaseId";
  private String senderCaseId;

  public static final String JSON_PROPERTY_CREATION_DATE = "creationDate";
  private OffsetDateTime creationDate;

  public static final String JSON_PROPERTY_DECISION_DATE = "decisionDate";
  private OffsetDateTime decisionDate;

  public static final String JSON_PROPERTY_RESSOURCE_FINESS_LEGAL =
      "ressourceFinessLegal";
  private String ressourceFinessLegal;

  public static final String JSON_PROPERTY_RESSOURCE_FINESS_GEO =
      "ressourceFinessGeo";
  private String ressourceFinessGeo;

  public static final String JSON_PROPERTY_RESSOURCE_STRUCTURE =
      "ressourceStructure";
  private String ressourceStructure;

  public Event() {}

  public Event orgId(String orgId) {

    this.orgId = orgId;
    return this;
  }

  /**
   * Numéro du SAMU régulant la mission SMUR.  A valoriser par fr.health.samuXXX
   *:  {pays}.{domaine}.{organisation}
   * @return orgId
   **/
  @JsonProperty(JSON_PROPERTY_ORG_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getOrgId() {
    return orgId;
  }

  @JsonProperty(JSON_PROPERTY_ORG_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setOrgId(String orgId) {
    this.orgId = orgId;
  }

  public Event senderCaseId(String senderCaseId) {

    this.senderCaseId = senderCaseId;
    return this;
  }

  /**
   * Numéro du dossier SAMU à l’origine de la mission SMUR A valoriser par
   *DRFR15DDXAAJJJ00000 :  - DR &#x3D; désignation d&#39;un dossier sous forme
   *abrégée, - FR : désigne le pays (FR &#x3D; France), - 15 : désigne le fait
   *que le dossier a été pris en charge par un SAMU / SAS, - DD : désigne le
   *département où est situé le SAMU / SAS qui a traité le dossier, - X : lettre
   *désignant le SAMU / SAS en cas de pluralité de SAMU / SAS sur le même
   *département ou le troisième chiffre des DOM, - AA : année durant laquelle
   *l’appel a été créé, - JJJ : désigne le jour de l&#39;année (de 1j à
   *365j),\\par - 00000 : numéro d’ordre chronologique du dossier dans la
   *journée de référence ci-dessus.
   * @return senderCaseId
   **/
  @JsonProperty(JSON_PROPERTY_SENDER_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getSenderCaseId() {
    return senderCaseId;
  }

  @JsonProperty(JSON_PROPERTY_SENDER_CASE_ID)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setSenderCaseId(String senderCaseId) {
    this.senderCaseId = senderCaseId;
  }

  public Event creationDate(OffsetDateTime creationDate) {

    this.creationDate = creationDate;
    return this;
  }

  /**
   * s&#39;exprime au format ISO 8601 YYY-MM-DDThh:mm:ss
   * @return creationDate
   **/
  @JsonProperty(JSON_PROPERTY_CREATION_DATE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public OffsetDateTime getCreationDate() {
    return creationDate;
  }

  @JsonProperty(JSON_PROPERTY_CREATION_DATE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setCreationDate(OffsetDateTime creationDate) {
    this.creationDate = creationDate;
  }

  public Event decisionDate(OffsetDateTime decisionDate) {

    this.decisionDate = decisionDate;
    return this;
  }

  /**
   * s&#39;exprime au format ISO 8601 YYY-MM-DDThh:mm:ss
   * @return decisionDate
   **/
  @JsonProperty(JSON_PROPERTY_DECISION_DATE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public OffsetDateTime getDecisionDate() {
    return decisionDate;
  }

  @JsonProperty(JSON_PROPERTY_DECISION_DATE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setDecisionDate(OffsetDateTime decisionDate) {
    this.decisionDate = decisionDate;
  }

  public Event ressourceFinessLegal(String ressourceFinessLegal) {

    this.ressourceFinessLegal = ressourceFinessLegal;
    return this;
  }

  /**
   * FINESS juridique établissement rattachement SMUR
   * @return ressourceFinessLegal
   **/
  @JsonProperty(JSON_PROPERTY_RESSOURCE_FINESS_LEGAL)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getRessourceFinessLegal() {
    return ressourceFinessLegal;
  }

  @JsonProperty(JSON_PROPERTY_RESSOURCE_FINESS_LEGAL)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setRessourceFinessLegal(String ressourceFinessLegal) {
    this.ressourceFinessLegal = ressourceFinessLegal;
  }

  public Event ressourceFinessGeo(String ressourceFinessGeo) {

    this.ressourceFinessGeo = ressourceFinessGeo;
    return this;
  }

  /**
   * FINESS géographique établissement rattachement SMUR ou antenne SMUR
   * @return ressourceFinessGeo
   **/
  @JsonProperty(JSON_PROPERTY_RESSOURCE_FINESS_GEO)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getRessourceFinessGeo() {
    return ressourceFinessGeo;
  }

  @JsonProperty(JSON_PROPERTY_RESSOURCE_FINESS_GEO)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setRessourceFinessGeo(String ressourceFinessGeo) {
    this.ressourceFinessGeo = ressourceFinessGeo;
  }

  public Event ressourceStructure(String ressourceStructure) {

    this.ressourceStructure = ressourceStructure;
    return this;
  }

  /**
   * 9 &#x3D; Antenne SMUR, 0 &#x3D; SMUR général, 1 &#x3D; SMUR pédiatrique, 2
   *&#x3D; SMUR neonatal
   * @return ressourceStructure
   **/
  @JsonProperty(JSON_PROPERTY_RESSOURCE_STRUCTURE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getRessourceStructure() {
    return ressourceStructure;
  }

  @JsonProperty(JSON_PROPERTY_RESSOURCE_STRUCTURE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setRessourceStructure(String ressourceStructure) {
    this.ressourceStructure = ressourceStructure;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Event event = (Event)o;
    return Objects.equals(this.orgId, event.orgId) &&
        Objects.equals(this.senderCaseId, event.senderCaseId) &&
        Objects.equals(this.creationDate, event.creationDate) &&
        Objects.equals(this.decisionDate, event.decisionDate) &&
        Objects.equals(this.ressourceFinessLegal, event.ressourceFinessLegal) &&
        Objects.equals(this.ressourceFinessGeo, event.ressourceFinessGeo) &&
        Objects.equals(this.ressourceStructure, event.ressourceStructure);
  }

  @Override
  public int hashCode() {
    return Objects.hash(orgId, senderCaseId, creationDate, decisionDate,
                        ressourceFinessLegal, ressourceFinessGeo,
                        ressourceStructure);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Event {\n");
    sb.append("    orgId: ").append(toIndentedString(orgId)).append("\n");
    sb.append("    senderCaseId: ")
        .append(toIndentedString(senderCaseId))
        .append("\n");
    sb.append("    creationDate: ")
        .append(toIndentedString(creationDate))
        .append("\n");
    sb.append("    decisionDate: ")
        .append(toIndentedString(decisionDate))
        .append("\n");
    sb.append("    ressourceFinessLegal: ")
        .append(toIndentedString(ressourceFinessLegal))
        .append("\n");
    sb.append("    ressourceFinessGeo: ")
        .append(toIndentedString(ressourceFinessGeo))
        .append("\n");
    sb.append("    ressourceStructure: ")
        .append(toIndentedString(ressourceStructure))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
