/**
 * Copyright © 2023-2025 Agence du Numerique en Sante (ANS)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 *
 *
 *
 *
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

package com.hubsante.model.technical.noreq;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import com.fasterxml.jackson.dataformat.xml.annotation.*;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Arrays;
import java.util.Objects;

/**
 * TechnicalObject
 */
@JsonPropertyOrder(
    {TechnicalObject.JSON_PROPERTY_OBJECT_PROPERTY_STRING,
     TechnicalObject.JSON_PROPERTY_OBJECT_PROPERTY_NUMBER,
     TechnicalObject.JSON_PROPERTY_OBJECT_PROPERTY_REQUIRED_STRING})
@JsonTypeName("technicalObject")
@JsonInclude(JsonInclude.Include.NON_EMPTY)

public class TechnicalObject {
  public static final String JSON_PROPERTY_OBJECT_PROPERTY_STRING =
      "objectPropertyString";
  private String objectPropertyString;

  public static final String JSON_PROPERTY_OBJECT_PROPERTY_NUMBER =
      "objectPropertyNumber";
  private BigDecimal objectPropertyNumber;

  public static final String JSON_PROPERTY_OBJECT_PROPERTY_REQUIRED_STRING =
      "objectPropertyRequiredString";
  private String objectPropertyRequiredString;

  public TechnicalObject() {}

  public TechnicalObject objectPropertyString(String objectPropertyString) {

    this.objectPropertyString = objectPropertyString;
    return this;
  }

  /**
   * Object property string
   * @return objectPropertyString
   **/
  @JsonProperty(JSON_PROPERTY_OBJECT_PROPERTY_STRING)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getObjectPropertyString() {
    return objectPropertyString;
  }

  @JsonProperty(JSON_PROPERTY_OBJECT_PROPERTY_STRING)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setObjectPropertyString(String objectPropertyString) {
    this.objectPropertyString = objectPropertyString;
  }

  public TechnicalObject objectPropertyNumber(BigDecimal objectPropertyNumber) {

    this.objectPropertyNumber = objectPropertyNumber;
    return this;
  }

  /**
   * Object property number
   * @return objectPropertyNumber
   **/
  @JsonProperty(JSON_PROPERTY_OBJECT_PROPERTY_NUMBER)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public BigDecimal getObjectPropertyNumber() {
    return objectPropertyNumber;
  }

  @JsonProperty(JSON_PROPERTY_OBJECT_PROPERTY_NUMBER)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setObjectPropertyNumber(BigDecimal objectPropertyNumber) {
    this.objectPropertyNumber = objectPropertyNumber;
  }

  public TechnicalObject
  objectPropertyRequiredString(String objectPropertyRequiredString) {

    this.objectPropertyRequiredString = objectPropertyRequiredString;
    return this;
  }

  /**
   * Required object property
   * @return objectPropertyRequiredString
   **/
  @JsonProperty(JSON_PROPERTY_OBJECT_PROPERTY_REQUIRED_STRING)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getObjectPropertyRequiredString() {
    return objectPropertyRequiredString;
  }

  @JsonProperty(JSON_PROPERTY_OBJECT_PROPERTY_REQUIRED_STRING)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void
  setObjectPropertyRequiredString(String objectPropertyRequiredString) {
    this.objectPropertyRequiredString = objectPropertyRequiredString;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TechnicalObject technicalObject = (TechnicalObject)o;
    return Objects.equals(this.objectPropertyString,
                          technicalObject.objectPropertyString) &&
        Objects.equals(this.objectPropertyNumber,
                       technicalObject.objectPropertyNumber) &&
        Objects.equals(this.objectPropertyRequiredString,
                       technicalObject.objectPropertyRequiredString);
  }

  @Override
  public int hashCode() {
    return Objects.hash(objectPropertyString, objectPropertyNumber,
                        objectPropertyRequiredString);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TechnicalObject {\n");
    sb.append("    objectPropertyString: ")
        .append(toIndentedString(objectPropertyString))
        .append("\n");
    sb.append("    objectPropertyNumber: ")
        .append(toIndentedString(objectPropertyNumber))
        .append("\n");
    sb.append("    objectPropertyRequiredString: ")
        .append(toIndentedString(objectPropertyRequiredString))
        .append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
